/*
 * TCP Test (PC Side)
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
	int sock;
	int length, n;
	int tempLength;

	struct sockaddr_in myAddr;
	struct sockaddr_in dcAddr;
	struct sockaddr_in tempAddr;
	struct sockaddr_in anyAddr;
	struct sockaddr_in from;

	char buffer[256];
	int retval;
	int bytesReceived;

	int good = 0;
	int bad = 0;
   

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0) {
		printf("socket error\n");
		return 0;
	}

	length = sizeof(myAddr);
	bzero(&myAddr, length);
	myAddr.sin_family = AF_INET;
	myAddr.sin_addr.s_addr = INADDR_ANY; //htonl(0xC0A800E0);
	myAddr.sin_port = htons(6000);

	length = sizeof(struct sockaddr_in);
	bzero(&dcAddr, length);
	dcAddr.sin_family = AF_INET;
	dcAddr.sin_addr.s_addr = htonl(0xC0A80004);
	dcAddr.sin_port = htons(8000);

	if(connect(sock, (struct sockaddr*)&dcAddr, sizeof(dcAddr)) < 0) {
		printf("connect error\n");
		return 0;
	}

/*
	retval = bind(sock, (struct sockaddr*)&myAddr, length);
	if(retval < 0) {
		printf("Server Bind Failed\n");
		return 0;
	}
*/

	printf("Starting Test\n");

	for(int i=0; i<0x10; i++) {
		strcpy(buffer, "TEST");
		//printf("Sending to %08x:%d\n", ntohl(dcAddr.sin_addr.s_addr), ntohs(dcAddr.sin_port));
		retval = send(sock, buffer, strlen(buffer), 0);
		if(retval < 0) {
			printf("write error\n");
			break;;
		}
		//printf("Sent\n");

		strcpy(buffer, "");

		//printf("Receiving\n");
		bytesReceived = recv(sock, buffer, 255, 0);
		if(bytesReceived < 0) {
			printf("read error\n");
			break;
		}
		//printf("Received from %08x:%d\n", ntohl(myAddr.sin_addr.s_addr), ntohs(myAddr.sin_port));

		if(strcmp(buffer, "TEST")) {
			bad++;
		} else {
			good++;
		}
	}

	printf("Test Complete\n");
	printf("Good: %d\n", good);
	printf("Bad : %d\n", bad);

	shutdown(sock, 2);

	return 0;
}