/*
 * TCP Test
 */

#include <dcos.h>

int main(void)
{
	int sock;
	int connSock;
	char buffer[256];
	struct sockaddr_in serverAddr;
	struct sockaddr_in clientAddr;
	int clientAddrLength;
	int bytesReceived;
	int retval;
	int connState;


	bzero((char *)&serverAddr, sizeof(serverAddr));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_addr.s_addr = INADDR_ANY;
	serverAddr.sin_port = htons(8000);

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0) {
		swlog("socket failed", 0, 0, 0, 0);
		return -1;
	}
	if(bind(sock, (struct sockaddr*)&serverAddr, sizeof(serverAddr)) < 0) {
		swlog("bind failed", 0, 0, 0, 0);
		return -1;
	}
	listen(sock, 5);

	connState = 0;
	connSock = 0;
	clientAddrLength = sizeof(clientAddr);
	while(1) {
		switch(connState) {
		case 0:
			connSock = accept(sock, (struct sockaddr*)&clientAddr, &clientAddrLength);
			if(connSock < 0) {
				swlog("accept failed", 0, 0, 0, 0);
				connState = 0;
			} else {
				connState = 1;
			}
			break;
		case 1:
			bzero(buffer, 256);
			bytesReceived = read(connSock, buffer, 255);
			if(bytesReceived < 0) {
				swlog("read failure", bytesReceived, 0, 0, 0);
				connState = 2;
			} else if(bytesReceived == 0) {
				/*
				 * Connection reset
				 */
				connState = 2;
			} else {
				//printkf("Received: %s\n", buffer);
				retval = write(connSock, buffer, bytesReceived);
				if(retval < 0) {
					swlog("write failure", retval, 0, 0, 0);
					connState = 2;
				} else {
					connState = 1;
				}
			}
			break;
		case 2:
			close(connSock);
			connState = 0;
			break;
		}

		SwitchToThread();
	}

	return 0;
}
