/*
 * UDP Test (PC Side)
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


// 192.168.0.4
#define DC_IPADDRESS	0xC0A80004

int main(int argc, char **argv)
{
	int sock;
	int length, n;
	int tempLength;

	struct sockaddr_in myAddr;
	struct sockaddr_in dcAddr;
	struct sockaddr_in tempAddr;
	struct sockaddr_in anyAddr;
	struct sockaddr_in from;

	char buffer[512];
	int retval;
	int bytesReceived;

	int good = 0;
	int bad = 0;
   

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock < 0) {
		printf("socket error\n");
		return 0;
	}

	length = sizeof(myAddr);
	bzero(&myAddr, length);
	myAddr.sin_family = AF_INET;
	myAddr.sin_addr.s_addr = INADDR_ANY; //htonl(0xC0A800E0);
	myAddr.sin_port = htons(6000);

	length = sizeof(struct sockaddr_in);
	bzero(&dcAddr, length);
	dcAddr.sin_family = AF_INET;
	dcAddr.sin_addr.s_addr = htonl(DC_IPADDRESS);
	dcAddr.sin_port = htons(7000);

	retval = bind(sock, (struct sockaddr*)&myAddr, length);
	if(retval < 0) {
		printf("Server Bind Failed\n");
		return 0;
	}

	printf("Starting Test\n");

	for(int i=0; i<0x100; i++) {
		//strcpy(buffer, "TEST");
		//printf("Sending to %08x:%d\n", ntohl(dcAddr.sin_addr.s_addr), ntohs(dcAddr.sin_port));
		retval = sendto(sock, buffer, 1024, 0, (const sockaddr*)&dcAddr, length);
		if(retval < 0) {
			printf("Sendto error\n");
			return -1;
		}
		//printf("Sent\n");

		strcpy(buffer, "");

		//printf("Receiving\n");
		bytesReceived = recvfrom(sock, buffer, 256, 0, (sockaddr*)&myAddr, &length);
		if(bytesReceived < 0) {
			printf("recvfrom error\n");
			return -1;
		}
		//printf("Received from %08x:%d\n", ntohl(myAddr.sin_addr.s_addr), ntohs(myAddr.sin_port));

		//if(strcmp(buffer, "TEST")) {
		//	bad++;
		//} else {
			good++;
		//}
	}

	printf("Test Complete\n");
	printf("Good: %d\n", good);
	printf("Bad : %d\n", bad);

	shutdown(sock, 2);

	return 0;
}
