/*
 * UDP Test
 */

#include <dcos.h>

int main(void)
{
	int sock, length, fromlen, n;
	struct sockaddr_in server;
	struct sockaddr_in from;
	char buffer[1024];
	int retval;
	int bytesReceived;

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock < 0) {
		swlog("Error Opening Socket", 0, 0, 0, 0);
	}

	length = sizeof(struct sockaddr_in);
	bzero(&server, length);
	server.sin_family = AF_INET;
	server.sin_addr.s_addr = INADDR_ANY;
	server.sin_port = htons(7000);


	retval = bind(sock, (struct sockaddr *)&server, length);
	if(retval < 0) {
		swlog("Error Binding Socket", 0, 0, 0, 0);
	}

	while(1) {
		fromlen = sizeof(struct sockaddr_in);
		/*
		 * Receive datagram
		 */
		//printk("Receiving\n");
		bytesReceived = recvfrom(sock, buffer, 1024, 0, (struct sockaddr *)&from, &fromlen);
		if(bytesReceived < 0) {
			swlog("recvfrom error", 0, 0, 0, 0);
		}
		//printkf("Received from %08x:%d\n", ntohl(from.sin_addr.s_addr), ntohs(from.sin_port));

		/*
		 * Echo datagram
		 */
		//printkf("Sending to %08x:%d\n", ntohl(from.sin_addr.s_addr), ntohs(from.sin_port));
		retval = sendto(sock, buffer, bytesReceived, 0, (struct sockaddr *)&from, fromlen);
		if(retval < 0) {
			swlog("sendto error", 0, 0, 0, 0);
		}
		//printk("Sent\n");
	}
	
	return 0;
}
